package com.huangge1199.config;

import com.alibaba.druid.pool.DruidDataSource;
import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Primary;

import javax.sql.DataSource;

/**
 * DataSourceConfig
 *
 * @author huangge1199
 * @since 2025/3/12 14:56:10
 */
@Configuration
public class DataSourceConfig {

    @Primary // 指定主数据源
    @Bean(name = "masterDataSource")
    public DataSource masterDataSource() {
        DruidDataSource dataSource = new DruidDataSource();
        dataSource.setUrl("jdbc:oracle:thin:@192.168.188.2:1521/xe");
        dataSource.setUsername("ruoyi");
        dataSource.setPassword("ruoyi");
        dataSource.setDriverClassName("oracle.jdbc.driver.OracleDriver");
        return dataSource;
    }

    // 仅当 enabled = true 时才启用从库数据源
    @Bean(name = "slaveDataSource")
    @ConditionalOnProperty(prefix = "spring.datasource.druid.slave", name = "enabled", havingValue = "true")
    public DataSource slaveDataSource() {
        DruidDataSource dataSource = new DruidDataSource();
        dataSource.setUrl("jdbc:oracle:thin:@192.168.188.2:1521/xe"); // 修改为实际的从库地址
        dataSource.setUsername("slave_user");
        dataSource.setPassword("slave_password");
        dataSource.setDriverClassName("oracle.jdbc.driver.OracleDriver");
        return dataSource;
    }
}
