package com.huangge1199.controller;

import com.huangge1199.base.R;
import com.huangge1199.service.IBiTableColumnService;
import com.huangge1199.vo.TableVo;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import java.util.List;

/**
 * BiController
 *
 * @author huangge1199
 * @since 2025/3/27 17:38:52
 */
@Api("数据库表操作")
@RestController
@RequestMapping("/db")
public class BiController {

    @Resource
    private IBiTableColumnService biTableColumnService;

    @ApiOperation("查询所有表信息")
    @PostMapping("/getTablesInfo")
    public R<List<TableVo>> getTablesInfo() {
        List<TableVo> result;
        try {
            result = biTableColumnService.getTablesInfo();
        } catch (Exception e) {
            return R.fail(e.getMessage());
        }
        return R.ok(result);
    }
}
