package com.huangge1199.dao;

import com.huangge1199.domain.UserTabComments;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.Query;

import java.util.List;

/**
 * DatabaseDao
 *
 * @author huangge1199
 * @since 2025/3/12 10:40:31
 */
public interface UserTabCommentsDao extends JpaRepository<UserTabComments,Long> {

    @Query(value = "SELECT TABLE_NAME, COMMENTS FROM USER_TAB_COMMENTS WHERE TABLE_NAME NOT LIKE 'BIN$%'" ,nativeQuery = true)
    List<UserTabComments> listAllTable();

    @Query(value = "SELECT col.column_name AS \"TABLE_NAME\",\n" +
            "       comm.comments AS \"COMMENTS\"\n" +
            "FROM all_tab_columns col\n" +
            "         LEFT JOIN all_col_comments comm\n" +
            "                   ON col.table_name = comm.table_name\n" +
            "                       AND col.column_name = comm.column_name\n" +
            "WHERE col.table_name = ?1",nativeQuery = true)
    List<UserTabComments> listColByTable(String tableName);
}
