package com.huangge1199.service.impl;

import com.huangge1199.dao.UserTabCommentsDao;
import com.huangge1199.domain.UserTabComments;
import com.huangge1199.service.IDatabaseService;
import org.springframework.stereotype.Service;

import javax.annotation.Resource;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.Query;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;
import java.util.*;

/**
 * DatabaseServiceImpl
 *
 * @author huangge1199
 * @since 2025/3/12 10:20:33
 */
@Service
public class DatabaseServiceImpl implements IDatabaseService {

    @Resource
    private UserTabCommentsDao databaseDao;

    @PersistenceContext
    private EntityManager entityManager;

    @Override
    public List<UserTabComments> listAllTable() {
        return databaseDao.listAllTable();
    }

    @Override
    public List<UserTabComments> listColByTable(String tableName) {
        return databaseDao.listColByTable(tableName);
    }

    @Override
    public List<Map<String, String>> executeQuery(String sql) {
        String cols = sql.substring(sql.toLowerCase().indexOf("select") + 6, sql.toLowerCase().lastIndexOf("from"));
        String[] colArr = cols.split(",");
        for (int i = 0; i < colArr.length; i++) {
            String col = colArr[i];
            if (col.toLowerCase().contains("as")) {
                if (col.contains("\"")) {
                    col = col.substring(col.indexOf("\"") + 1, col.lastIndexOf("\""));
                } else if (col.contains("'")) {
                    col = col.substring(col.indexOf("'") + 1, col.lastIndexOf("'"));
                }
            }
            colArr[i] = col;
        }
        Query query = entityManager.createNativeQuery(sql);
        List<Object[]> resultList = query.getResultList();
        List<Map<String, String>> result = new ArrayList<>();
        for (Object[] row : resultList) {
            Map<String, String> map = new HashMap<>(colArr.length);
            for (int i = 0; i < colArr.length; i++) {
                map.put(colArr[i], row[i].toString());
            }
            result.add(map);
        }
        return result;
    }

    @Override
    public double evaluate(String expression) throws Exception {
        expression = expression.replaceAll(" ","");
        ScriptEngineManager manager = new ScriptEngineManager();
        ScriptEngine engine = manager.getEngineByName("JavaScript");
        double result = 0;
        try {
            result = Double.parseDouble(engine.eval(expression).toString());
            System.out.println("计算结果: " + result);
        } catch (ScriptException e) {
            System.out.println(e.getMessage());
            throw new Exception("表达式错误");
        }
        return result;
    }
}
